function [x,b] = spirall1(A0,y,b,x0,l1reg,niter)

eta = 2;
sigma = 0.1;
M = 6;
tol = 1e-10;
alphamin = 1e-20;
alphamax = 1e20;

if isa(A0,'function_handle')
	A = @(x) A0(x,1);
	At = @(y) A0(y,2);
else
	A = @(x) A0*x;
	At = @(y) A0'*y;
end

% m = numel(y);
% n = numel(x0);
x = max(x0,0);
d = x;
dtd = d'*d;
Ad = A(d);
Axb = Ad+b;
maxrecent = inf;

% xrec = nan(n,niter);
objrec = nan(niter,1);
breakcount = 0;
for i = 1:niter
	xprev = x;
	Axbprev = Axb;
	alpha0 = (y'*(Ad./Axb).^2)/dtd;
	alpha = min(max(alpha0,alphamin),alphamax);
	
	yoAx = y./Axb;
	gradx = At(1-yoAx);
	
	while true
		s = xprev - gradx/alpha;
		x = max(s - l1reg/alpha,0);
		d = x-xprev;
		dtd = d'*d;
		Axb = A(x)+b;
		obj = sum(Axb-y.*log(Axb)) + l1reg*sum(x);
% 		break
% 		fprintf('\talpha=%g   obj=%g\n',alpha,obj)
		if alpha >= alphamax || obj <= maxrecent - sigma*alpha/2 * dtd
			break
		else
			alpha = eta*alpha;
		end
	end
	objrec(i) = obj;
	
% 	lambda = max(-s,0);
% 	kkt = norm(gradx+l1reg-lambda,2); % doesn't actually go to zero
% 	fprintf('iter: %i:   obj=%g   kkt=%g   alpha=%g   d=%g\n',i,obj,kkt,alpha,norm(d))
% 	if kkt < tol || i>=niter
% 		break
% 	end
	
	if norm(d) < tol
		breakcount = breakcount+1;
		if breakcount >= 3
% 			fprintf('iter: %i:   obj=%g   alpha=%g   d=%g\n',i,obj,alpha,norm(d))
			break
		end
	else
		breakcount = 0;
	end
% 	fprintf('iter: %i:   obj=%g   alpha=%g   d=%g\n',i,obj,alpha,norm(d))
	
	Ad = Axb-Axbprev;
	maxrecent = max(objrec(max(i-M-1,1):i));
end

end