function t = toeptrial2(nspecies,nmeas,nbin,ppulse,noisepow)

% nmeas = 1e6;
% npulse = 1e4;
% nbin = 9e3;
% nspecies = 300;
% noisepow = 0;

randu = @(a,b,m,n) a + (b-a)*rand(m,n); % generate uniform rv

tofs = sort(randperm(nbin,nspecies))'; % time of flight for present species % don't allow repeats

minabundance = 0.1;
abundance = 10.^randu(log10(minabundance),0,nspecies,1); % expected number of each species per pulse
% abundance = randu(minabundance,1,nspecies,1);

npbin = nmeas-nbin+1;
if ppulse == 0
	pulsetimes = 0:nbin:npbin-1;
else
	pulsetimes = find(rand(npbin,1)<ppulse)-1';
end
npulse = numel(pulsetimes);
% npulse = binornd(nmeas-nbin+1,ppulse); pulsetimes = (sort(randperm(nmeas-nbin+1,npulse))'-1);


a1 = zeros(npbin,1); a1(pulsetimes+1) = 1;
% a2 = [zeros(nbin-1,1);a1(end:-1:1);zeros(nbin-1,1)];
a2 = zeros(nmeas+nbin-1,1); a2(nmeas:-1:nbin) = a1;
function z = Afun(x,mode) % perform A*x and A'*y
	switch mode
		case {1,'notransp'}
			z = zeros(nmeas,size(x,2));
			for i = 1:size(x,2)
				z(:,i) = conv(a1,x(1:nbin,i),'full');
			end
		case {2,'transp'}
			z = zeros(nbin,size(x,2));
			for i = 1:size(x,2)
				z(1:nbin,i) = conv(a2,x(:,i),'valid');
			end
% 		case {1,'notransp'}
% 			z = conv2(a1,x,'full'); % actually slower than just for-looping
% 		case {2,'transp'}
% 			a22 = zeros(size(a2,1),2*size(x,2)-1);
% 			a22(:,size(x,2)) = a2;
% 			z = conv2(a22,x,'valid'); % actually slower than just for-looping
		otherwise
			error('Invalid Mode');
	end
end
% depbins = repmat(1:nbin,npulse,1);
% arrtimes = bsxfun(@plus,pulsetimes,depbins);
% A = sparse(arrtimes,depbins,true,nmeas,nbin);
% acorr = Afun(a1,2); % autocorrelation of a


if all(abundance <= 0) % this should never happen
	error('Abundances all equal 0 - no events to create')
end

xtrue = sparse(tofs,1,abundance,nbin,1);
y = poissrnd(Afun(full(xtrue),1)+noisepow);

% y = poissrnd(Afun(full(xtrue),1)) + sqrt(noisepow)*randn(nmeas,1);
% y = poissrnd(full(A*xtrue)) + sqrt(noisepow)*randn(nmeas,1);

% x1 = spg_lasso(A,y,sum(abundance),spgSetParms('verbosity',0));
% [xls,~] = lsqr(A,y,1e-7,50);
% x1 = spg_lasso(@Afun,y,sum(abundance),spgSetParms('verbosity',0));
% x1 = poisson_mlreg(@Afun,y,noisepow,full(xtrue),0,150);
x1 = spirall1(@Afun,y,noisepow,full(xtrue),nmeas*ppulse,150);
% x1 = spirall1(@Afun,y,noisepow,full(xtrue),0,150);
% x1 = cosamp(@Afun,y,nspecies,30);
% [xls,~] = lsqr(@Afun,y,1e-7,50);

x1(x1<minabundance/4) = 0;
% xls(xls<minabundance/4) = 0;

t = struct('Nmeasurements',nmeas,'Npulses',npulse,'Nbins',nbin,'Nspecies',nspecies,'true_abundance',xtrue,'rec_abundance',x1);
% stem([full(xtrue),x1,xls])
end